﻿var IsPlaySound;

var oldContent;

function Load()
{
  var input_h = document.createElement("input");
  input_h.type = "hidden";
  input_h.value = System.Gadget.Settings.readString("CurrentSession");
  input_h.id = "session_value";
  document.appendChild(input_h);
  IsPlaySound = System.Gadget.Settings.readString("playsnd")  == "True";  
  oldContent = document.getElementById("old").innerHTML;
  document.getElementById("old").innerHTML = "";
  var img = document.createElement("IMG");
  img.src = "../../images/loading24.gif";
  img.style.paddingLeft = 8;
  document.getElementById("old").appendChild(img);
  document.getElementById("old").innerHTML += "<span class='font' style='padding-left: 8px'>Загружаются контакты пользователя...</span>"; 
  GetContacts(document.getElementById("session_value").value);
}

function CheckUserData()
{
  if (document.getElementById("walletNumber").value.toString().match(/[0-9]{12}/) == null)
  {
    document.getElementById("messageField").style.color = "#FF6666";
    document.getElementById("messageField").innerHTML = "Введен неверный номер кошелька или длина кошелька меньше 12 цифр"; 
    return false;
  }
  if (isNaN(Number(document.getElementById("amount").value)) || document.getElementById("amount").value.toString().replace(/^\s*|\s*$/g,"") == "")
  {
    document.getElementById("messageField").style.color = "#FF6666";
    document.getElementById("messageField").innerHTML = "Введенная сумма перевода имеет неверный формат"; 
    return false;
  }
  return true;
}

function CreateTransfer(session)
{
  if (CheckUserData())
  {
    service.useService("ProcessingService.wsdl","Processing");
    var callObj;
    var SoapHeader = "<SessionKey>"+session+"</SessionKey>";
    callObj = service.createCallOptions();
    callObj.async = true;
    callObj.SOAPHeader = new Array();
    callObj.SOAPHeader[0] = SoapHeader;
    callObj.params = new Array();
    callObj.params.ToUserId = document.getElementById("walletNumber").value;
    callObj.params.Amount = document.getElementById("amount").value;
    callObj.params.CurrencyId = document.getElementById("currencyType").value;
    callObj.params.Description = document.getElementById("description").value.toString().replace(/^\s*|\s*$/g,"");
    callObj.params.UnlockCode = document.getElementById("unlockCode").value.toString().replace(/^\s*|\s*$/g,"");
    callObj.funcName = "CreateTransfer";
    var iCallID = service.Processing.callService(_CreateTransfer, callObj);
  }
}

function _CreateTransfer(result)
{
  if(result.error)
  {
    var xfaultcode   = result.errorDetail.code;
    var xfaultstring = result.errorDetail.string;
    var xfaultsoap   = result.errorDetail.raw;
    if (xfaultsoap != null)
    {
      try
      {
        document.getElementById("messageField").style.color = "#FF6666";
        document.getElementById("messageField").innerHTML = xfaultsoap.getElementsByTagName("message")[0].text;
      }
      catch(e)
      {
        document.getElementById("messageField").style.color = "#FF6666";
        document.getElementById("messageField").innerHTML = result.errorDetail.string;
      }
    }
    else
    {
      document.getElementById("messageField").style.color = "#FF6666";
      document.getElementById("messageField").innerHTML = xfaultstring;
    }
  }
  else
  {
    document.getElementById("messageField").style.color = "#FFFFFF";
    document.getElementById("messageField").innerHTML = "Перевод успешно создан";
    ClearFields();
  } 
}

function GetContacts(session)
{
  service.useService("InteractionService.wsdl","Interaction");
  var SoapHeader = "<SessionKey>"+session+"</SessionKey>";
  var callObj;
  callObj = service.createCallOptions();
  callObj.async = true;
  callObj.SOAPHeader = new Array();
  callObj.SOAPHeader[0] = SoapHeader;
  callObj.params = new Array();
  callObj.funcName = "GetContacts";
  var iCallID = service.Interaction.callService(_GetContacts, callObj);
}

function _GetContacts(result)
{
  if(result.error)
  {
    var xfaultcode   = result.errorDetail.code;
    var xfaultstring = result.errorDetail.string;
    var xfaultsoap   = result.errorDetail.raw;
    if (xfaultsoap != null)
    {
      document.getElementById("messageField").style.color = "#FF6666";
      document.getElementById("messageField").innerHTML = xfaultsoap.getElementsByTagName("message")[0].text;
    }
    else
    {
      document.getElementById("messageField").style.color = "#FF6666";
      document.getElementById("messageField").innerHTML = xfaultstring;
    }
  }
  else
  {
    document.getElementById("old").innerHTML = oldContent;
    GenerateContactList(result.raw.getElementsByTagName("Contact"));
  } 
}

function GenerateContactList(list)
{
  for (var i=0; i<list.length; i++)
  {
    var op = document.createElement("option");
    op.title = list[i].getAttribute("Title");
    op.value = list[i].getAttribute("ContactUserId");
    op.label = list[i].getAttribute("Title")+" ("+list[i].getAttribute("ContactUserId")+")";
    document.getElementById("contactList").appendChild(op);
  }
}

function SelectContact()
{
  if (document.getElementById("contactList").value == "0")
  {
    document.getElementById("walletNumber").value = "";
  }
  else
  {
    document.getElementById("walletNumber").value = document.getElementById("contactList").value;
  }
}

function walletNumberChange()
{
  if (document.getElementById("walletNumber").value.toString().length>0)
  {
    for (var i=0; i<document.getElementById("contactList").length; i++)
    {
      if (document.getElementById("contactList").options[i].value.toString().search(new RegExp("^"+document.getElementById("walletNumber").value+"[0-9]{"+(12-document.getElementById("walletNumber").value.toString().length).toString()+"}$")) != -1)
      {
        document.getElementById("contactList").selectedIndex = i;
        return;  
      }
      else
      {
        document.getElementById("contactList").selectedIndex = 0;
      }
    }
  }
  else
  {
    document.getElementById("contactList").selectedIndex = 0;
  }
}

function Transfer()
{
  try
  {
    //SendSMS(document.getElementById("session_value").value,document.getElementById("smsPhone").value,document.getElementById("smsMessages").value);
    document.getElementById("messageField").style.color = "White";
    document.getElementById("messageField").innerHTML = "Инициирование перевода...";
  }
  catch (e)
  {
    document.getElementById("messageField").style.color = "#FF6666";
    document.getElementById("messageField").innerHTML = "Ошибка при инициировании перевода: "+e.message;
  }  
}

function ClearFields()
{
  document.getElementById("walletNumber").value = "";
  document.getElementById("amount").value = "";
  document.getElementById("description").value = "";
  document.getElementById("unlockCode").value = "";
}
