﻿var Version = "0.9.0.0"; //Версия гаджета

var UpdateInterval = 600; //Интервал обновления данных в секундах
var TimerHandler = null; //Указатель на таймер обновления контента
var IsPlaySound = true; //Проигрывать звуки или нет
var IsIconVisible = true; //Показывать иконки провайдеров или нет
var Mode = "login";
var Balance = NaN; 
var IsEvent = false;

//========Данные о пользователе=======================================
var _Login = "";
var _Password = "";
var _CurrentSession = "";
var _UserId = "";
//====================================================================


function HandleW1Error(error)
{
  switch (error.getElementsByTagName("code")[0].text)
  {
    case "SESSION_KEY_EXPIRED":
    case "SESSION_KEY_NOT_FOUND":
    {
      Load();
      break;
    }
    default:
    {
      setError(xfaultsoap.getElementsByTagName("message")[0].text); 
      break;
    }
  }
}
    
function _GetSessionResult(result)
{
  if(result.error)
  {
    var xfaultcode   = result.errorDetail.code;
    var xfaultstring = result.errorDetail.string;
    var xfaultsoap   = result.errorDetail.raw;
    if (xfaultsoap != null)
    {
      HandleW1Error(xfaultsoap);
    }
    else
    {
      setError(xfaultstring); 
    }
  }
  else
  {
   System.Gadget.Settings.write("CurrentSession", result.raw.getElementsByTagName("SessionKey")[0].text);
   _CurrentSession = result.raw.getElementsByTagName("SessionKey")[0].text;
   _UserId = result.raw.getElementsByTagName("SessionUserId")[0].text;
   System.Gadget.Settings.write("CurrentUserId", _UserId);
   var appversion = result.raw.getElementsByTagName("CurrentVersion")[0].text;
   if (appversion != Version)
   {
     if (result.raw.getElementsByTagName("UpdateUrl")[0] != null)
      {
        if (IsPlaySound)
        {
          System.Sound.playSound("..\\snd\\update.wav");
        }
        setError("Доступна новая <br/>версия гаджета. Пожалуйста обновите <a style='color: #FFFFFF' href='"+result.raw.getElementsByTagName("UpdateUrl")[0].text+"'>Скачать</a>");
        return;
      }
   }
   GetUserBalance();
  } 
}

function GetSession()
{
  service.useService("SecurityService.wsdl","Security");
  var callObj;
  callObj = service.createCallOptions();
  callObj.async = true;
  callObj.params = new Array();
  callObj.params.Login = _Login;
  callObj.params.Password = b64_sha1(_Password);
  callObj.params.LoginType = "Auto";
  callObj.params.ClientId = "w1_vista_gadget";
  callObj.funcName = "GetSessionTicket";
  var iCallID = service.Security.callService(_GetSessionResult, callObj);
}

function _GetCurrencyListResult(result)
{
  if(result.error)
  {
    var xfaultcode   = result.errorDetail.code;
    var xfaultstring = result.errorDetail.string;
    var xfaultsoap   = result.errorDetail.raw;
    if (xfaultsoap != null)
    {
      HandleW1Error(xfaultsoap);
    }
    else
    {
      setError(xfaultstring); 
    }
  }
  else
  {
    
  } 
}

function GetCurrencyListResult(result)
{
  var callObj;
  callObj = service.createCallOptions();
  callObj.async = false;
  callObj.params = new Array();
  callObj.funcName = "GetCurrencyList";
  var iCallID = service.Processing.callService(_GetCurrencyListResult, callObj);
  _GetCurrencyListResult(iCallID);
}

function GetUserBalance()
{
  service.useService("ProcessingService.wsdl","Processing");
  var SoapHeader = "<SessionKey>"+_CurrentSession+"</SessionKey>";
  var callObj;
  callObj = service.createCallOptions();
  callObj.async = true;
  callObj.SOAPHeader = new Array();
  callObj.SOAPHeader[0] = SoapHeader;
  callObj.params = new Array();
  callObj.funcName = "GetUserBalance";
  var iCallID = service.Processing.callService(_GetUserBalanceResult, callObj);
}

function _GetUserBalanceResult(result)
{
  if(result.error)
  {
    var xfaultcode   = result.errorDetail.code;
    var xfaultstring = result.errorDetail.string;
    var xfaultsoap   = result.errorDetail.raw;
    if (xfaultsoap != null)
    {
      HandleW1Error(xfaultsoap);
    }
    else
    {
      setError(xfaultstring); 
    }
  } 
  else
  {
    //Пока показываем только рублевый баланс
    var balanceArray = result.raw.getElementsByTagName("UserBalance");
    for(var i=0; i<balanceArray.length; i++)
    {
      if (balanceArray[i].getElementsByTagName("CurrencyId")[0].text == "643")
      {
        if (isNaN(Balance))
        {
          Balance = parseFloat(balanceArray[i].getElementsByTagName("Amount")[0].text);
        }
        else
        {
          if (Balance < parseFloat(balanceArray[i].getElementsByTagName("Amount")[0].text))
          {
            Balance = parseFloat(balanceArray[i].getElementsByTagName("Amount")[0].text);
            if (IsPlaySound && Mode == "update")
            {
              System.Sound.playSound("..\\snd\\recive_money.wav");
            }
          }
        }
        Balance = parseFloat(balanceArray[i].getElementsByTagName("Amount")[0].text);
        document.getElementById("currentAmount").style.color = "#999999"; 
        document.getElementById("currentAmount").innerHTML = Number(Balance).toFixed(2).toString()+" руб.";
        break;
      }
    }
    GetSMSCount();
  }
}

function _GetSMSCount(result)
{
  if(result.error)
  {
    var xfaultcode   = result.errorDetail.code;
    var xfaultstring = result.errorDetail.string;
    var xfaultsoap   = result.errorDetail.raw;
    if (xfaultsoap != null)
    {
      HandleW1Error(xfaultsoap);
    }
    else
    {
      setError(xfaultstring); 
    }
  }
  else
  {
    document.getElementById("leftCountSMS").innerText = result.value;
    GetInvoiceCount(); 
  } 
}

function GetSMSCount()
{
  service.useService("SmsService.wsdl","Interaction");
  var SoapHeader = "<SessionKey>"+_CurrentSession+"</SessionKey>";
  var callObj;
  callObj = service.createCallOptions();
  callObj.async = true;
  callObj.SOAPHeader = new Array();
  callObj.SOAPHeader[0] = SoapHeader;
  callObj.params = new Array();
  callObj.funcName = "GetBonusMessageCountLeft";
  var iCallID = service.Interaction.callService(_GetSMSCount, callObj);
}



function _GetTransferCount(result)
{
  if(result.error)
  {
    var xfaultcode   = result.errorDetail.code;
    var xfaultstring = result.errorDetail.string;
    var xfaultsoap   = result.errorDetail.raw;
    if (xfaultsoap != null)
    {
      HandleW1Error(xfaultsoap);
    }
    else
    {
      setError(xfaultstring); 
    }
  }
  else
  {
    var NewTransfer = result.raw.getElementsByTagName("New")[0].text;
    if (parseInt(NewTransfer)>0)
    {
      document.getElementById("currentAmount").style.color = "#FF6666";
      document.getElementById("currentAmount").innerHTML = "<a href=\"javascript:showInfo('transfer')\">Новых переводов: " + NewTransfer+"</a>";
      if (IsPlaySound && !IsEvent)
      {
        System.Sound.playSound("..\\snd\\new_invoice.wav");
      }
      IsEvent = true;
      Visi();
    }
    else
    {
      IsEvent = false;
      document.getElementById("notifiPanel").innerHTML = "Нет новых событий";
    }
    Visi();
  }
}

function GetTransferCount()
{
  service.useService("ProcessingService.wsdl","Processing");
  var SoapHeader = "<SessionKey>"+_CurrentSession+"</SessionKey>";
  var callObj;
  callObj = service.createCallOptions();
  callObj.async = true;
  callObj.SOAPHeader = new Array();
  callObj.SOAPHeader[0] = SoapHeader;
  callObj.params = new Array();
  callObj.funcName = "GetTransferCount";
  var iCallID = service.Processing.callService(_GetTransferCount, callObj);
}

function _GetInvoiceCount(result)
{
  if(result.error)
  {
    var xfaultcode   = result.errorDetail.code;
    var xfaultstring = result.errorDetail.string;
    var xfaultsoap   = result.errorDetail.raw;
    if (xfaultsoap != null)
    {
      HandleW1Error(xfaultsoap);
    }
    else
    {
      setError(xfaultstring); 
    }
  }
  else
  {
    var NewInvoice = result.raw.getElementsByTagName("New")[0].text;
    if (parseInt(NewInvoice)>0)
    {
      document.getElementById("currentAmount").style.color = "#FF6666";
      document.getElementById("currentAmount").innerHTML = "<a href=\"javascript:showInfo('invoice')\">Новых счетов: "+NewInvoice+"</a>";
      if (IsPlaySound && !IsEvent)
      {
        System.Sound.playSound("..\\snd\\new_invoice.wav");
      }
      IsEvent = true;
      Visi();
    }
    else
    {
      IsEvent = false;
      GetTransferCount();
    }
  }
}

function GetInvoiceCount()
{
  service.useService("ProcessingService.wsdl","Processing");
  var SoapHeader = "<SessionKey>"+_CurrentSession+"</SessionKey>";
  var callObj;
  callObj = service.createCallOptions();
  callObj.async = true;
  callObj.SOAPHeader = new Array();
  callObj.SOAPHeader[0] = SoapHeader;
  callObj.params = new Array();
  callObj.funcName = "GetInvoiceCount";
  var iCallID = service.Processing.callService(_GetInvoiceCount, callObj);
}
 
function Load()
{
  try
  {
    Mode = "login";
    document.getElementById("ErrorPanel").style.visibility = "hidden"; 
    System.Gadget.background = "../images/d.png";
    System.Gadget.settingsUI = "settings.html";
    System.Gadget.onSettingsClosed = function(event)
    {
      if (event.closeAction == event.Action.commit)
      {
        reloadContent();
      }
    }
    _Login = System.Gadget.Settings.readString("login");
    _Password = System.Gadget.Settings.readString("password");
    UpdateInterval = System.Gadget.Settings.readString("updateInterval");
    IsPlaySound = System.Gadget.Settings.readString("playsnd") == "True";
    
    if (_Login == "" || _Password == "")
    {
      document.getElementById("TextError").innerText = "Не задан логин и пароль. Зайдите в настройки для установки этих данных";
      document.getElementById("ContentPanel").style.visibility = "hidden"; 
      document.getElementById("ErrorPanel").style.visibility = "visible"; 
      document.getElementById("LoadPanel").style.visibility = "hidden"; 
      if (document.getElementById("btn_registration") != null)
      {
        document.getElementById("btn_registration").style.visibility = "visible";
      }
      else
      {
        var bt_element = document.createElement("br");
        document.getElementById("ErrorPanel").appendChild(bt_element);
        var btn_registration = document.createElement("a");
        btn_registration.id = "btn_registration";
        btn_registration.style.backgroundImage = "url(../../images/button.png)";
        btn_registration.style.color = "#FFFFFF";
        btn_registration.innerText = "Регистрация";
        btn_registration.style.fontFamily = "Tahoma";
        btn_registration.style.fontSize = "11px";
        btn_registration.style.height = 22;
        btn_registration.style.width = 90;
        btn_registration.style.paddingTop = 4;
        btn_registration.style.textDecoration = "none";
        btn_registration.style.border = "none";
        btn_registration.style.backgroundColor = "Transparent";
        btn_registration.href = "javascript:regClick()";
        document.getElementById("ErrorPanel").appendChild(btn_registration);
      }
      return;
    }
    
    GetSession();
      
    TimerHandler = setInterval("Update()", UpdateInterval*1000);
  }
  catch(e)
  {
    if (e != null)
    {
      setError(e.message);
    }
  }
}

function reloadContent()
{
  if (TimerHandler != null)
    clearInterval(TimerHandler);
  document.getElementById("ContentPanel").style.visibility = "hidden";
  document.getElementById("LoadPanel").style.visibility = "visible";
  Load();
}

function Visi()
{
  document.getElementById("ErrorPanel").style.visibility = "hidden";
  if (IsPlaySound && Mode == "login")
  {
    System.Sound.playSound("..\\snd\\login.wav");
  }
  document.getElementById("LoadPanel").style.visibility = "hidden";
  document.getElementById("ContentPanel").style.visibility = "visible";
}

function Update()
{
  document.getElementById("ErrorPanel").style.visibility = "hidden";
  Mode = "update";
  GetUserBalance();
}

function setError(string)
{
  if (document.getElementById("btn_registration") != null)
        document.getElementById("btn_registration").style.visibility = "hidden";
  document.getElementById("TextError").innerHTML = string;
  document.getElementById("ContentPanel").style.visibility = "hidden"; 
  document.getElementById("ErrorPanel").style.visibility = "visible"; 
  document.getElementById("LoadPanel").style.visibility = "hidden"; 
}

//Оплата услуг
function payment()
{
  try
  {
    if (System.Gadget.Flyout.show) 
    {
      System.Gadget.Flyout.show = false;
    }
    System.Gadget.Flyout.file = "FlyoutPayment.htm";
    System.Gadget.Flyout.show = true;
    System.Gadget.Flyout.onShow = function()
    {
      var inp1 = System.Gadget.Flyout.document;
      var input_h = inp1.createElement("input");
      input_h.type = "hidden";
      input_h.value = _CurrentSession;
      input_h.id = "session_value";
      inp1.appendChild(input_h);
    }
    System.Gadget.Flyout.onHide = function()
    {
      Update();
    }   
   }
   catch (e)
   {
     setError(e.message);
   } 
}

//Отправка СМС
function sendSMSClick()
{
  try
  { 
      if (System.Gadget.Flyout.show) 
      {
        System.Gadget.Flyout.show = false;
      }
      System.Gadget.Flyout.file = "FlyoutSMS.htm";
      System.Gadget.Flyout.show = true;
      System.Gadget.Flyout.onShow = function()
      {
        var inp1 = System.Gadget.Flyout.document;
        var input_h = inp1.createElement("input");
        input_h.type = "hidden";
        input_h.value = _CurrentSession;
        input_h.id = "session_value";
        inp1.appendChild(input_h);
      }
      System.Gadget.Flyout.onHide = function()
      {
        Update();
      }   
  }
  catch(e)
  {
    setError(e.message);
  }    
}

//Регистрация
function regClick()
{
  try
  { 
    if (System.Gadget.Flyout.show) 
    {
      System.Gadget.Flyout.show = false;
    }
    System.Gadget.Flyout.file = "FlyoutReg.htm";
    System.Gadget.Flyout.show = true;
  }
  catch(e)
  {
    setError(e.message);
  }    
}

//Создать перевод
function transferClick()
{
  try
  { 
    if (System.Gadget.Flyout.show) 
    {
      System.Gadget.Flyout.show = false;
    }
    System.Gadget.Flyout.file = "FlyoutTransfer.htm";
    System.Gadget.Flyout.show = true;
    System.Gadget.Flyout.onHide = function()
    {
       Update();
    }   
  }
  catch(e)
  {
    setError(e.message);
  }    
}

function loadSite()
{
  var s = new ActiveXObject("WScript.Shell");
  s.Run("http://www.w1.ru");
}


function showInfo(type)
{
  try
  { 
    if (System.Gadget.Flyout.show) 
    {
      System.Gadget.Flyout.show = false;
    }
    System.Gadget.Settings.write("typex", type);
    System.Gadget.Flyout.file = "FlyoutNotify.htm";
    System.Gadget.Flyout.show = true;
    System.Gadget.Flyout.onHide = function()
    {
      Update();
    }   
  }
  catch(e)
  {
    setError(e.message);
  }    
}
