﻿var IsPlaySound;


function ShowWaitingContent(message)
{
  document.getElementById("providerList").innerHTML = "";
  var img = document.createElement("IMG");
  img.src = "../../images/loading24.gif";
  document.getElementById("providerList").appendChild(img);
  document.getElementById("providerList").innerHTML += "<span class='font' style='padding-left: 8px'>"+message+"</span>"; 
}

function Load()
{
  document.getElementById("providerLogo").onerror = function()
  {
    document.getElementById("providerLogo").style.visibility = "hidden";
  }
  IsPlaySound = System.Gadget.Settings.readString("playsnd")  == "True";  
}

function StopFindProvider()
{
  try
  {
    ShowWaitingContent("Ждите... Идет поиск...");
    FindProvider(session_value.value,document.getElementById("searchBox").value);
  }
  catch(e)
  {
  } 
  CloseFind();
}
function CloseFind()
{
  document.getElementById("middle_layer").style.visibility = "hidden";
  document.getElementById("find_window").style.visibility = "hidden";
  document.getElementById("searchBox").value = "";
}

function searchBoxKeyUp()
{
  switch (event.keyCode)
  {
    case 13:
    {
      StopFindProvider(); 
      break;
    }
    case 27:
    {
      CloseFind();
      break;
    }
  }
}

function FindProviderClick()
{
  document.getElementById("middle_layer").style.visibility = "visible";
  document.getElementById("find_window").style.visibility = "visible";
  document.getElementById("searchBox").focus();
}


function GetGroup()
{
  try
  {
    ShowWaitingContent("Ждите... Идет загрузка групп...");
    GetProviderGroups(document.getElementById("session_value").value);
  }
  catch (e)
  {
  }
}

function GetFavourite()
{
  try
  {
    ShowWaitingContent("Ждите... Идет загрузка избранных провайдеров...");
    GetFavouriteProviders(document.getElementById("session_value").value);
  }
  catch (e)
  {
  }
}
function CancelPayment()
{
  document.getElementById("providerSelect").style.visibility = "visible";
  document.getElementById("paymentPanel").style.visibility = "hidden";
  document.getElementById("providerLogo").style.visibility = "hidden";
}

function imageLoadError()
{
  document.getElementById("providerLogo").style.visibility = "hidden";
}
    
function _GetProviderGroups(result)
{
  if(result.error)
  {
    var xfaultcode   = result.errorDetail.code;
    var xfaultstring = result.errorDetail.string;
    var xfaultsoap   = result.errorDetail.raw;
    if (xfaultsoap != null)
    {
      document.getElementById("providerList").innerText = xfaultstring;
    }
  }
  else
  {
    document.getElementById("providerList").innerHTML = "";
    var provider_group = result.raw.getElementsByTagName("ProviderGroup");
    for (var i=0; i<provider_group.length; i++)
    {
      var br_el = document.createElement("br");
      var clickElement = document.createElement("a");
      clickElement.style.color = "#FFFFFF"; 
      clickElement.style.fontFamily = "Tahoma";
      clickElement.style.fontSize = "12px";
      clickElement.style.fontWeight = "bold";
      clickElement.style.paddingLeft = "4px";
      clickElement.href="javascript:GetProviders(document.getElementById('session_value').value,'"+provider_group[i].getAttribute("ProviderGroupId")+"')";
      clickElement.innerHTML = provider_group[i].getElementsByTagName("Title")[0].text;
      document.getElementById("providerList").innerHTML+="<img src='../../images/bullet.png' style='padding-left: 8px'/>";
      document.getElementById("providerList"). appendChild(clickElement);
      document.getElementById("providerList").appendChild(br_el);
    }
  }
} 

function GetProviderGroups(session)
{
  service.useService("PaymentService.wsdl","Payment");
  var SoapHeader = "<SessionKey>"+session+"</SessionKey>";
  var callObj;
  callObj = service.createCallOptions();
  callObj.async = true;
  callObj.SOAPHeader = new Array();
  callObj.SOAPHeader[0] = SoapHeader;
  callObj.params = new Array();
  callObj.params.ProviderGroupId = null;
  callObj.funcName = "GetProviderGroups";
  var iCallID = service.Payment.callService(_GetProviderGroups, callObj);
}

function _GetProviders(result)
{
  if(result.error)
  {
    var xfaultcode   = result.errorDetail.code;
    var xfaultstring = result.errorDetail.string;
    var xfaultsoap   = result.errorDetail.raw;
    if (xfaultsoap != null)
    {
      document.getElementById("providerList").innerText = xfaultstring;
    }
  }
  else
  {
    document.getElementById("providerList").innerHTML = "";
    CreateProviderList(result.raw.getElementsByTagName("Provider"));
  }
}

function CreateProviderList(provider)
{
  for (var i=0; i<provider.length; i++)
  {
    var br_el = document.createElement("br");
    var clickElement = document.createElement("a");
    clickElement.style.color = "#FFFFFF"; 
    clickElement.style.fontFamily = "Tahoma";
    clickElement.style.fontSize = "12px";
    clickElement.style.fontWeight = "bold";
    clickElement.style.paddingLeft = "8px";
    clickElement.href="javascript:ProcessPayment(document.getElementById('session_value').value,'"+provider[i].getAttribute("ProviderId")+"',null,null,null)";
    clickElement.innerHTML = provider[i].getElementsByTagName("Title")[0].text;
    document.getElementById("providerList").innerHTML+="<img src='../../images/bullet.png' style='padding-left: 8px'/>";
    document.getElementById("providerList").appendChild(clickElement);
    document.getElementById("providerList").appendChild(br_el);
  }
}

function GetProviders(session,providerGroupId)
{
  ShowWaitingContent("Ждите... Идет загрузка провайдеров группы...");
  service.useService("PaymentService.wsdl","Payment");
  var SoapHeader = "<SessionKey>"+session+"</SessionKey>";
  var callObj;
  callObj = service.createCallOptions();
  callObj.async = true;
  callObj.SOAPHeader = new Array();
  callObj.SOAPHeader[0] = SoapHeader;
  callObj.params = new Array();
  callObj.params.ProviderGroupId = providerGroupId;
  callObj.funcName = "GetProviders";
  var iCallID = service.Payment.callService(_GetProviders, callObj);
}

function _GetFavouriteProviders(result)
{
  if(result.error)
  {
    var xfaultcode   = result.errorDetail.code;
    var xfaultstring = result.errorDetail.string;
    var xfaultsoap   = result.errorDetail.raw;
    if (xfaultsoap != null)
    {
      document.getElementById("providerList").innerText = xfaultstring;
    }
  }
  else
  {
    document.getElementById("providerList").innerHTML = "";
    CreateProviderList(result.raw.getElementsByTagName("Provider"));
  }
}

function GetFavouriteProviders(session)
{ 
  service.useService("PaymentService.wsdl","Payment");
  var SoapHeader = "<SessionKey>"+session+"</SessionKey>";
  var callObj;
  callObj = service.createCallOptions();
  callObj.async = true;
  callObj.SOAPHeader = new Array();
  callObj.SOAPHeader[0] = SoapHeader;
  callObj.params = new Array();
  callObj.funcName = "GetFavouriteProviders";
  var iCallID = service.Payment.callService(_GetFavouriteProviders, callObj);
}

function _FindProvider(result)
{
  if(result.error)
  {
    var xfaultcode   = result.errorDetail.code;
    var xfaultstring = result.errorDetail.string;
    var xfaultsoap   = result.errorDetail.raw;
    if (xfaultsoap != null)
    {
      document.getElementById("providerList").innerText = xfaultsoap.getElementsByTagName("message")[0].text;
    }
  }
  else
  {
    document.getElementById("providerList").innerHTML = "";
    CreateProviderList(result.raw.getElementsByTagName("Provider"));
  }
}

function FindProvider(session,searchString)
{
  service.useService("PaymentService.wsdl","Payment");
  var SoapHeader = "<SessionKey>"+session+"</SessionKey>";
  var callObj;
  callObj = service.createCallOptions();
  callObj.async = true;
  callObj.SOAPHeader = new Array();
  callObj.SOAPHeader[0] = SoapHeader;
  callObj.params = new Array();
  callObj.params.SearchString = searchString;
  callObj.funcName = "FindProvider";
  var iCallID = service.Payment.callService(_FindProvider, callObj);
}

function _ProcessPayment(result)
{
  if(result.error)
  {
    var xfaultcode   = result.errorDetail.code;
    var xfaultstring = result.errorDetail.string;
    var xfaultsoap   = result.errorDetail.raw;
    if (xfaultsoap != null)
    {
      document.getElementById("errorText").innerHTML = xfaultsoap.getElementsByTagName("message")[0].text;
    }
  }
  else
  {
    document.getElementById("errorText").innerHTML = "";
    GenerateStep(result.raw);
  }
}

//Переменные для проведения платежа
var PaymentId = null;
var ProviderId = null;
var State = null;
var Step = null;
var StepCount = null;
var FormId = null;

function GenerateStep(stepData)
{
  try
  {
    if (document.getElementById("paymentPanel").style.visibility == "hidden")
    {
      document.getElementById("providerSelect").style.visibility = "hidden";
      document.getElementById("paymentPanel").style.visibility = "visible";
      document.getElementById("paymentButton").disabled = false;
    }  
    State = stepData.getElementsByTagName("State")[0].text;
    if (State == "Processing")
    {
      document.getElementById("paymentButton").disabled = true;
      document.getElementById("paymentForm").style.color = "#FFFFFF";
      document.getElementById("paymentForm").innerHTML = "Платеж отправлен на обработку... Для платежа создан новый перевод. Что бы узнать статус перевода можно пройти по ссылке <a href='http://www.w1.ru/client'>http://www.w1.ru/client</a>.";
      System.Sound.playSound("..\\snd\\create_pay.wav");
      return;
    }
    PaymentId = stepData.getElementsByTagName("PaymentId")[0].text;
    ProviderId = stepData.getElementsByTagName("ProviderId")[0].text;
    Step = stepData.getElementsByTagName("Step")[0].text;
    StepCount = stepData.getElementsByTagName("StepCount")[0].text;
    document.getElementById("providerLogo").style.visibility = "visible";
    document.getElementById("providerLogo").src = "../../images/provider_logo/"+ProviderId+".png";
    document.getElementById("stepNumber").innerHTML = Step;
    document.getElementById("providerTitle").innerHTML = stepData.getElementsByTagName("Form")[0].getElementsByTagName("Title")[0].text;
    var paymentTable = document.createElement("table");
    paymentTable.id = PaymentId; 
    var fields = stepData.getElementsByTagName("Form")[0].getElementsByTagName("Fields")[0];
    FormId =  stepData.getElementsByTagName("Form")[0].getAttribute("FormId");
    for (var i=0; i<fields.childNodes.length; i++)
    {
      switch(fields.childNodes[i].nodeName)
      {
        case "ListField":
        {
          var tr = document.createElement("tr");
          var tdl = document.createElement("td");
          tr.id = fields.childNodes[i].getAttribute("FieldId");
          tdl.style.color = "#FFFFFF";
          tdl.style.fontFamily = "Tahoma";
          tdl.style.fontSize = "11px";
          tdl.style.fontWeight = "bold"; 
          tdl.style.textAlign = "right";
          tdl.innerHTML = fields.childNodes[i].getElementsByTagName("Title")[0].text;
          var tdv = document.createElement("td");
          var listField = document.createElement("select");
          var items = fields.childNodes[i].getElementsByTagName("Item");
          for (var j=0; j<items.length; j++)
          {
            var option = document.createElement("option");
            listField.options.add(option);
            option.innerText = items[j].getElementsByTagName("Title")[0].text;
            option.value = items[j].getElementsByTagName("Value")[0].text;
            option.selected = items[j].getAttribute("IsSelected");
          }
          listField.style.width = 150;
          listField.style.backgroundColor = "Transparent";
          listField.style.border = "solid 1px #FFFFFF";
          tdv.appendChild(listField);
          tr.appendChild(tdl);
          tr.appendChild(tdv);
          paymentTable.appendChild(tr); 
          break;
        }
        case "ScalarField":
        {
          tr = document.createElement("tr");
          tdl = document.createElement("td");
          tr.id = fields.childNodes[i].getAttribute("FieldId");
          tdl.style.color = "#FFFFFF";
          tdl.style.fontFamily = "Tahoma";
          tdl.style.fontSize = "11px";
          tdl.style.fontWeight = "bold"; 
          tdl.style.textAlign = "right";
          tdl.innerHTML = fields.childNodes[i].getElementsByTagName("Title")[0].text;
          tdv = document.createElement("td");
          var textField = document.createElement("input");
          textField.type = "text";
          textField.style.width = 150;
          textField.style.backgroundColor = "Transparent";
          textField.style.border = "solid 1px #FFFFFF";
          textField.style.color = "#FFFFFF";
          tdv.appendChild(textField);
          tr.appendChild(tdl);
          tr.appendChild(tdv);
          paymentTable.appendChild(tr);
          break;
        }
      }
    }
    document.getElementById("paymentForm").innerHTML = paymentTable.outerHTML;
  }
  catch (e)
  {
    document.getElementById("paymentForm").innerHTML = e.message;
  }
}

function NextStep(session)
{
  var formXML = "";
  var elem = document.getElementById(PaymentId);
  var name_fields = elem.getElementsByTagName("tr");
  for (var i=0; i<name_fields.length; i++)
  {
    switch(name_fields[i].getElementsByTagName("td")[1].childNodes[0].nodeName)
    {
      case "INPUT":
      {
        formXML+="<ScalarParam FieldId=\""+name_fields[i].id+"\"><Value>"+name_fields[i].getElementsByTagName("td")[1].childNodes[0].value+"</Value></ScalarParam>";
        break;
      }
      case "SELECT":
      {
        formXML+="<ListParam FieldId=\""+name_fields[i].id+"\"><Items><Value>"+name_fields[i].getElementsByTagName("td")[1].childNodes[0].value+"</Value></Items></ListParam>";
        break;
      }
    }
  }
  ProcessPayment(session,ProviderId,PaymentId,FormId,formXML);
}

function ProcessPayment(session, providerId, paymentId, formId, params)
{
  service.useService("PaymentService.wsdl","Payment");
  var SoapHeader = "<SessionKey>"+session+"</SessionKey>";
  var callObj;
  callObj = service.createCallOptions();
  callObj.async = true;
  callObj.SOAPHeader = new Array();
  callObj.SOAPHeader[0] = SoapHeader;
  callObj.params = new Array();
  callObj.params.ProviderId = providerId;
  callObj.params.PaymentId = paymentId;
  callObj.params.FormId = formId;
  callObj.params.Params = params;
  callObj.funcName = "ProcessPayment";
  var iCallID = service.Payment.callService(_ProcessPayment, callObj);
} 