﻿var IsPlaySound;
var CaptchaId;

function Load()
{
  IsPlaySound = System.Gadget.Settings.readString("playsnd")  == "True";  
  GetCaptcha();
}

function _GetCaptcha(result)
{
  if(result.error)
  {
    var xfaultcode   = result.errorDetail.code;
    var xfaultstring = result.errorDetail.string;
    var xfaultsoap   = result.errorDetail.raw;
    if (xfaultsoap != null)
    {
      document.getElementById("messageField").innerHTML = xfaultsoap.getElementsByTagName("message")[0].text; 
    }
    else
    {
      document.getElementById("messageField").innerHTML = xfaultsoap; 
    }
  }
  else
  {
    CaptchaId = result.raw.getElementsByTagName("CaptchaId")[0].text;
    document.getElementById("CaptchaId").src = result.raw.getElementsByTagName("ImageUrl")[0].text;
  }
}

function GetCaptcha()
{
  service.useService("SecurityService.wsdl","Security");
  var callObj;
  callObj = service.createCallOptions();
  callObj.async = true;
  callObj.params = new Array();
  callObj.params.Width = 96;
  callObj.params.Height = 48;
  callObj.funcName = "GetCaptcha";
  var iCallID = service.Security.callService(_GetCaptcha, callObj);
}

function _RegisterUser(result)
{
  if(result.error)
  {
    var xfaultcode   = result.errorDetail.code;
    var xfaultstring = result.errorDetail.string;
    var xfaultsoap   = result.errorDetail.raw;
    if (xfaultsoap != null)
    {
      document.getElementById("messageField").innerHTML = xfaultsoap.getElementsByTagName("message")[0].text; 
      document.getElementById("captchaValue").value = "";
      GetCaptcha();
    }
    else
    {
      document.getElementById("messageField").innerHTML = xfaultsoap; 
      document.getElementById("captchaValue").value = "";
      GetCaptcha();
    }
  }
  else
  {
    document.getElementById("messageField").innerHTML = "Новый кошелек зарегистрирован. После того как вы получите сообщение с логином и паролем. Пропишите его в настройках Гаджета";
    ClearFields();
  }
}

function RegisterUser()
{
  service.useService("https://services.w1.ru/10/RegistrationService.asmx?WSDL","Registration");
  var callObj;
  callObj = service.createCallOptions();
  callObj.async = true;
  callObj.params = new Array();
  callObj.params.RegistratorId = "w1";
  callObj.params.MessageDeliveryMethod = document.getElementById("methodDelivery").value;
  callObj.params.MessageTarget = document.getElementById("loginName").value;
  callObj.params.CaptchaId = CaptchaId;
  callObj.params.CaptchaCode = document.getElementById("captchaValue").value;
  callObj.funcName = "RegisterUser";
  var iCallID = service.Registration.callService(_RegisterUser, callObj);
}

function SendReg()
{
  try
  {
    RegisterUser();
    document.getElementById("messageField").style.color = "White";
    document.getElementById("messageField").innerHTML = "Сообщение отправляется...";
  }
  catch (e)
  {
    document.getElementById("messageField").style.color = "#FF6666";
    document.getElementById("messageField").innerHTML = "Ошибка при отправке сообщения: "+e.message;
    document.getElementById("captchaValue").value = "";
    GetCaptcha();
  }  
}

function ClearFields()
{
  document.getElementById("loginName").value = "";
  document.getElementById("captchaValue").value = "";
  GetCaptcha();
}