﻿var IsPlaySound;

function Load()
{
  IsPlaySound = System.Gadget.Settings.readString("playsnd")  == "True";  
  var input_h = document.createElement("input");
  input_h.type = "hidden";
  input_h.value = System.Gadget.Settings.readString("CurrentSession");
  input_h.id = "session_value";
  document.appendChild(input_h);
}


function ActivateSMSService()
{
  document.getElementById("smsContent").style.display = "block";
  document.getElementById("menuContent").style.display = "none";
  document.getElementById("callbackContent").style.display = "none";
}

function ActivateCallbackService()
{
  document.getElementById("callbackContent").style.display = "block";
  document.getElementById("smsContent").style.display = "none";
  document.getElementById("menuContent").style.display = "none";
}

function ActivateMenu()
{
  document.getElementById("menuContent").style.display = "block";
  document.getElementById("callbackContent").style.display = "none";
  document.getElementById("smsContent").style.display = "none";
}


function CheckCall()
{
  document.getElementById("LoadPanel").style.display = "block";
  document.getElementById("nextb").disabled = "disabled";
  try
  {
    service.useService("VoipService.wsdl","Voip");
    var SoapHeader = "<SessionKey>"+document.getElementById("session_value").value+"</SessionKey>";
    var callObj;
    callObj = service.createCallOptions();
    callObj.async = true;
    callObj.SOAPHeader = new Array();
    callObj.SOAPHeader[0] = SoapHeader;
    callObj.funcName = "CallbackInitializeEx";
    callObj.params = new Array();
    callObj.params.PhoneNumber1 = document.getElementById("phoneFrom").value;
    callObj.params.PhoneNumber2 = document.getElementById("phoneTo").value;
    callObj.params.IsAnonimous = false;
    var iCallID = service.Voip.callService(_CheckCall, callObj);
  }
  catch (e)
  {
    document.getElementById("infoStr").innerHTML = e.message+" d";
  }
  
}

function _CheckCall(result)
{
  if(result.error)
  {
    var xfaultcode   = result.errorDetail.code;
    var xfaultstring = result.errorDetail.string;
    var xfaultsoap   = result.errorDetail.raw;
    document.getElementById("infoStr").style.color = "#FF6666";
    document.getElementById("infoStr").innerHTML = xfaultsoap.getElementsByTagName("message")[0].text;
  }
  else
  {
    document.getElementById("LoadPanel").style.display = "none";
    document.getElementById("nextb").disabled = null;
    document.getElementById("nextb").value = "Позвонить";
    GenerateNextStep(result.raw);
  } 
}

var CallID = null;
var MaxDuration = null;
var CallingDirection = null;
var CallingMinuteCost = null;
var CallingConnectCost = null;
var CalledDirection = null;
var CalledMinuteCost = null;
var CalledConnectCost = null;

function GenerateNextStep(responseInit)
{
  try
  {
    var res = responseInit.getElementsByTagName("CallbackInitializeExResult")[0];
    document.getElementById("phoneInput").style.display = "none";
    document.getElementById("callInfo").style.display = "block";
    CallID = res.getAttribute("CallId");
    MaxDuration = res.getAttribute("MaxDuration");
    CallingDirection = res.getAttribute("CallingDirection");
    CallingMinuteCost = res.getAttribute("CallingMinuteCost");
    CallingConnectCost = res.getAttribute("CallingConnectCost");
    CalledDirection = res.getAttribute("CalledDirection");
    CalledMinuteCost = res.getAttribute("CalledMinuteCost");
    CalledConnectCost = res.getAttribute("CalledConnectCost");
    document.getElementById("x1").innerText = document.getElementById("phoneFrom").value;
    document.getElementById("y1").innerText = document.getElementById("phoneTo").value;
    
    document.getElementById("x2").innerText = CallingDirection;
    document.getElementById("y2").innerText = CalledDirection;
    
    document.getElementById("x3").innerText = CallingMinuteCost;
    document.getElementById("y3").innerText = CalledMinuteCost;
    document.getElementById("a3").innerText = Number(MaxDuration);
    document.getElementById("z3").innerText = Number(CalledMinuteCost)+Number(CallingMinuteCost);
  }
  catch (e)
  {
  }
}

function CallPerform()
{
    service.useService("VoipService.wsdl","Voip");
    var SoapHeader = "<SessionKey>"+document.getElementById("session_value").value+"</SessionKey>";
    var callObj;
    callObj = service.createCallOptions();
    callObj.async = true;
    callObj.SOAPHeader = new Array();
    callObj.SOAPHeader[0] = SoapHeader;
    callObj.funcName = "CallbackPerform";
    callObj.params = new Array();
    callObj.params.CallId = CallID;
    var iCallID = service.Voip.callService(_CallPerform, callObj);   
}

function _CallPerform(result)
{
  if(result.error)
  {
    var xfaultcode   = result.errorDetail.code;
    var xfaultstring = result.errorDetail.string;
    var xfaultsoap   = result.errorDetail.raw;
    document.getElementById("sd").style.color = "#FF6666";
    document.getElementById("sd").innerHTML = xfaultstring;// xfaultsoap.getElementsByTagName("message")[0].text;  
  }
  else
  {
    document.getElementById("callB").disabled = "disabled"; 
    document.getElementById("sd").style.color = "#FFFFFF";
    document.getElementById("sd").innerHTML = "Звонок инициирован. Ждите."
  }
}



function _SendSMS(result)
{
  if(result.error)
  {
    var xfaultcode   = result.errorDetail.code;
    var xfaultstring = result.errorDetail.string;
    var xfaultsoap   = result.errorDetail.raw;
    document.getElementById("messageField").style.color = "#FF6666";
    document.getElementById("messageField").innerHTML = xfaultstring; //xfaultsoap.getElementsByTagName("message")[0].text;
  }
  else
  {
    document.getElementById("messageField").style.color = "White";
    document.getElementById("messageField").innerHTML = "Сообщение отправлено";
    if (IsPlaySound)
    {
      System.Sound.playSound("..\\snd\\send_sms.wav");
    }
    ClearFields();
  } 
}
    
function SendSMS(session, phoneTo, message)
{
  service.useService("SmsService.wsdl","Sms");
  var SoapHeader = "<SessionKey>"+session+"</SessionKey>";
  var callObj;
  callObj = service.createCallOptions();
  callObj.async = true;
  callObj.SOAPHeader = new Array();
  callObj.SOAPHeader[0] = SoapHeader;
  callObj.params = new Array();
  callObj.params.PhoneNumber = phoneTo;
  callObj.params.Text = message;
  callObj.params.CurrencyId = 643;
  callObj.funcName = "SendMessage";
  var iCallID = service.Sms.callService(_SendSMS, callObj);
}

function Send()
{
  try
  {
    SendSMS(document.getElementById("session_value").value,document.getElementById("smsPhone").value,document.getElementById("smsMessages").value);
    document.getElementById("messageField").style.color = "White";
    document.getElementById("messageField").innerHTML = "Сообщение отправляется...";
  }
  catch (e)
  {
    document.getElementById("messageField").style.color = "#FF6666";
    document.getElementById("messageField").innerHTML = "Ошибка при отправке сообщения: "+e.message;
  }  
}

function ClearFields()
{
  document.getElementById("smsPhone").value = "";
  document.getElementById("smsMessages").value = "";
}

function TextAreaTextChange()
{
  var x = document.getElementById("smsMessages").value.toString();
  if (x.length>=100)
  {
    document.getElementById("smsMessages").value = x.substring(0,99);
  }
}